function chart_pos_order_customer (widget) {
    "use strict";

    var model = openerp;

    widget.ChartPosOrderCustomerWidget = widget.Base.extend({
        template: 'ChartPosOrderCustomer',
        data: [],

        events: {
            
        },
        init: function (parent) {
            this._super(parent, {
                width: 6,
                height: 4
            });
        },
        start: function () {
            var self = this;
            self.fetchInitial();
        },
        fetchInitial:function() {
            var self = this;
            self.fetchCurrentUser().then(function (CurrentUser) {
                return CurrentUser;
            }).then(function (CurrentUser) {
                self.CurrentUser = CurrentUser;
                return self.fetchResUser(CurrentUser);
            }).then(function(ResUser) {
                self.ResUser = ResUser;
                return self.fetchAccountJournal();
            }).then(function(AccountJournal) {
                self.AccountJournal = AccountJournal;
                return self.fetchPosOrder();
            }).then(function (PosOrder) {
                self.PosOrder = PosOrder;
                return self.fetchAccountInvoice();
            }).then(function (AccountInvoice) {
                self.AccountInvoice = AccountInvoice;
                return self.fetchResPartner();
            }).then(function (ResPartner) {
                self.ResPartner = ResPartner;
                 return self.fetchResCompany();
            }).then(function(ResCompany) {
                self.ResCompany = ResCompany;
                return self.fetchResCurrency();
            }).then(function(ResCurrency) {
                self.ResCurrency = ResCurrency;
                return self.fetchCustomerRanking();
            });
        },

        /* 
            USER
        */

        fetchCurrentUser: function() {
            var self = this;
            var ResUser = new model.web.Model('res.users');
            return ResUser.call('get_user', {
                context: new model.web.CompoundContext()
            });
        },

        fetchResUser: function(id) {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','store_id'];
            var domain = [['id','=',id]];
            var ResUser = new model.web.Model('res.users');
            ResUser.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });

            return defer;
        },

        fetchAccountJournal: function() {
            var self = this;
            var defer = $.Deferred();
            var store_ids = self.ResUser[0].store_id[0];
            var fields = ['id', 'name', 'store_ids'];
            var domain = [['type','=','sale'],['store_ids','in',store_ids]];
            var AccountJournal = new model.web.Model('account.journal');
            AccountJournal.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        fetchPosOrder: function() {
            var self = this;
            var journal_ids = _.flatten(_.map(self.AccountJournal, function (item) {
                return item.id;
            }));
            var desde = moment().format('YYYY-MM-01 00:00:00');
            var hasta = moment().add(1,'months').format('YYYY-MM-01 00:00:00');
            var defer = $.Deferred();
            var fields = ['id','date_order','partner_id','amount_total'];
            var domain = [['state', 'in', ['paid','done','invoiced']], ['partner_id', '!=', false], ['date_order', '>=', desde], ['date_order', '<', hasta],['sale_journal','in',journal_ids]];
            var PosOrder = new model.web.Model('pos.order');
            PosOrder.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        

        fetchAccountInvoice: function() {
            var self = this;
            var journal_ids = _.flatten(_.map(self.AccountJournal, function (item) {
                return item.id;
            }));
            var desde = moment().format('YYYY-MM-01 00:00:00');
            var hasta = moment().add(1,'months').format('YYYY-MM-01 00:00:00');
            var defer = $.Deferred();
            var fields = ['id','date_invoice','partner_id','amount_total','currency_id'];
            var domain = [['state', 'in', ['open','paid']], ['date_invoice', '>=', desde],['date_invoice', '<', hasta],['type','=','out_invoice'],['journal_id','in',journal_ids]];
            var AccountInvoice = new model.web.Model('account.invoice');
            AccountInvoice.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        fetchResPartner: function() {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id', 'name'];
            var domain = [['active', '=', true],['customer', '=', true]];
            var ResPartner = new model.web.Model('res.partner');
            ResPartner.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        fetchResCompany: function() {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name', 'currency_id'];
            var domain = [['id', '=', 1]];
            var ResCompany = new model.web.Model('res.company');
            ResCompany.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });

            return defer;
        },

        fetchResCurrency : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position'];
            var domain = [['active', '=', true]];
            var ResCurrency = new model.web.Model('res.currency');
            ResCurrency.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        getResCurrency: function (id) {
            var self = this;
            return _.filter(self.ResCurrency,function (item) {
                return item.id === id;
            })
        },

        getPosOrder:function(id) {
            var self = this;
            var tz = moment.tz.guess();
            return _.flatten(_.filter(self.PosOrder,function (inv) {
                var utc = moment.utc(inv.date_order,'YYYY-MM-DD h:mm:ss A');
                return inv.partner_id[0] === id & utc.clone().tz(tz).format("YYYY-MM") === moment().format('YYYY-MM');
            }));
        },

        getAccountInvoice:function(id) {
            var self = this;
            return _.flatten(_.filter(self.AccountInvoice,function (inv) {
                return inv.partner_id[0] === id;
            }));
        },

        // Generar el Ranking
        fetchCustomerRanking: function() {
            var self = this;
            console.log(self);
            var PosOrder;
            var AccountInvoice;
            var countPosOrder = 0
            var ranking = [];
            var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
            for (var i = 0; i < self.ResPartner.length; i++) {
                var data = [];
                PosOrder = self.getPosOrder(self.ResPartner[i].id);
                AccountInvoice = self.getAccountInvoice(self.ResPartner[i].id);              
                var pos_order_amount = _.reduce(_.map(PosOrder,function(item) {
                    return item.amount_total;
                }),function(memo, num) {
                    return memo + num;
                },0);
                var account_invoice_amount = 0;
                if(AccountInvoice.length > 0){
                    _.each(AccountInvoice, function (item) {
                        var currency = self.getResCurrency(item.currency_id[0]).shift();
                        data.push({
                            amount: item.amount_total * (CurrencyBase.rate_silent / currency.rate_silent),
                        })
                    });
                    var account_invoice_amount = _.reduce(_.map(data,function(item) {
                        return item.amount;
                    }),function(memo, num) {
                        return memo + num;
                    },0);
                }  
                var amount = pos_order_amount + account_invoice_amount;
                
                if(amount > 0 ){
                    ranking.push({
                        id: self.ResPartner[i].id,
                        name: self.ResPartner[i].name,
                        countPosOrder: amount
                    });    
                }
            }
            ranking.sort(function (a, b) {
                return b.countPosOrder - a.countPosOrder
            });
            self.fetchChart(ranking);
        },

        // Generar Grafico
        fetchChart: function (ranking) {
            var self = this;
            var label = [];
            var body = [];
            var item;
            var rank = 7;
            if (ranking.length < rank && ranking.length > 0 ){
                rank= ranking.length;
            }
            for (var i = 0; i < rank; i++) {
                if (ranking[i]) {
                    item = ranking[i];
                }
                if (ranking.length === 0) {
                    item = {};
                    item.name = "N/A";
                    item.countPosOrder = 0;
                }
                label.push(item.name);
                body.push(item.countPosOrder);
            }
            
            Chart.scaleService.updateScaleDefaults('linear', {
              ticks: {
                callback: function(tick) {
                    return tick.toLocaleString('de-DE');
                }
              }
            });
            
            Chart.defaults.global.tooltips.callbacks.label = function(tooltipItem, data) {
                var dataset = data.datasets[tooltipItem.datasetIndex];
                var datasetLabel = dataset.label || '';
                return datasetLabel +  dataset.data[tooltipItem.index].toLocaleString('de-DE');
            };

            var chart = new Chart(this.$el.find(".widget-content").find('canvas'), {
                type: 'horizontalBar',
                data: {
                    labels: label,
                    datasets: [
                        {
                            label: 'Ranking  ',
                            backgroundColor: '#bbdefb',
                            borderColor: '#0288d1',
                            borderWidth: 1,
                            data: body,
                            fill: false,
                        }
                    ]
                },
                options: {
                    responsive: true,
                    legend: {
                        display: false,
                    },
                    title: {
                        display: false,
                    },
                    layout: {
                        padding: {
                            top: 0,
                            bottom: 45,
                            left : 0,
                            rigth: 0,
                        }
                    },
                    events: ['click'],
                    elements: {
                        line: {
                            tension: 0.000001
                        },
                    },
                }
            });
        },
    });
}
